export interface CustomObjectOption {
    id?: string;
    children?: CustomObject[];
    width: number;
    height: number;
}
export interface CustomObjectMeta {
    getChildren: () => CustomObject[];
    getId: () => string;
    getWidth: () => number;
    getHeight: () => number;
    getPosition: () => Position;
    setId: (id: string) => void;
    setChildren: (childTables: CustomObject[]) => void;
    setChild: (childTables: CustomObject) => void;
    setWidth: (width: number) => void;
    setHeight: (height: number) => void;
    setPosition: (position: Position) => void;
}
export declare class CustomObject implements CustomObjectMeta {
    private children;
    private id;
    private width;
    private height;
    private position;
    constructor({ children, id, width, height }: CustomObjectOption);
    getChildren: () => CustomObject[];
    getId: () => string;
    getWidth: () => number;
    getHeight: () => number;
    getPosition: () => Position;
    setChild: (childTable: CustomObject) => void;
    setChildren: (childTables: CustomObject[]) => void;
    setId: (id: string) => void;
    setWidth: (width: number) => void;
    setHeight: (height: number) => void;
    setPosition: (position: Position) => void;
    clone: () => CustomObject;
}
export interface Position {
    x: number;
    y: number;
}
export interface CustomObjectFormated extends CustomObject {
    group?: string;
    level?: number;
}
export interface SortedGroups {
    root: CustomObjectFormated;
    children: SortedGroups[];
}
export declare enum Orientation {
    vertical = "vertical",
    horizontal = "horizontal"
}
export interface LayoutCoordinator {
    prepare: (data: CustomObject[]) => void;
    execute: () => void;
}
export interface LayoutCoordinatorExtra {
    customObjectSpace: number;
    orientation: Orientation;
}
