"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Orientation = exports.CustomObject = void 0;
const uuid_1 = require("uuid");
class CustomObject {
    constructor({ children = [], id, width, height }) {
        this.position = { x: 0, y: 0 };
        this.getChildren = () => this.children;
        this.getId = () => this.id;
        this.getWidth = () => this.width;
        this.getHeight = () => this.height;
        this.getPosition = () => this.position;
        this.setChild = (childTable) => {
            this.children.push(childTable);
            this.children = this.children.sort((a, b) => (b.getChildren().length || 0) - (a.getChildren().length || 0));
        };
        this.setChildren = (childTables) => {
            this.children = childTables.sort((a, b) => (b.getChildren().length || 0) - (a.getChildren().length || 0));
        };
        this.setId = (id) => {
            this.id = id;
        };
        this.setWidth = (width) => {
            this.width = width;
        };
        this.setHeight = (height) => {
            this.height = height;
        };
        this.setPosition = (position) => {
            this.position = position;
        };
        this.clone = () => {
            const cloned = new CustomObject({
                id: this.id,
                children: this.children,
                width: this.width,
                height: this.height
            });
            return cloned;
        };
        this.children = children;
        this.id = id ? id : (0, uuid_1.v4)();
        this.width = width;
        this.height = height;
    }
}
exports.CustomObject = CustomObject;
var Orientation;
(function (Orientation) {
    Orientation["vertical"] = "vertical";
    Orientation["horizontal"] = "horizontal";
})(Orientation || (exports.Orientation = Orientation = {}));
